<?php 
add_action( 'gform_user_updated', 'sg_update_s2data', 10, 4 );

/*******************************************************
  Notes on the $entry Values in the following function 

 All $entry values are retrieved using the Field ID   except the Stripe Transaction ID (which is not a field entry). Ths function works for ALL forms which have a 
 User Registration and Stripe feed.                
 ******************************************************/

function sg_update_s2data( $user_id, $feed, $entry, $user_pass ) {  
    $form_id = $entry['form_id'];
    $form = GFAPI::get_form($form_id);
    $fields = $form['fields'];
    
    // Assign values to variables based on form field values
    $sg_eot_period = get_value_by_label_new( $fields, $entry, 'EOT Period' );
    $sg_ccaps = get_value_by_label_new( $fields, $entry, 'CCAPS' );
    $sg_user = $user_id;
    $sg_txnid = rgar( $entry, 'transaction_id');
        
    $op['op'] = 'modify_user'; // The Remote Operation.

// Save Data
$op['api_key'] = '5NLF8LF6HE9VK6RYQLTEVTGGQCWVZR7QI1ECMB0WP2I7LJC58'; // 

$op['data'] = array(
    'user_id'    => $sg_user, // A WordPress® User ID.
    's2member_ccaps' => $sg_ccaps, 
    's2member_subscr_gateway' => 'stripe', 
    's2member_subscr_id'      => $sg_txnid, 
    's2member_auto_eot_time' => $sg_eot_period,
    );
$post_data = stream_context_create(array('http' => array('method' => 'POST', 'header' => 'Content-type: application/x-www-form-urlencoded', 'content' => 's2member_pro_remote_op='.urlencode(json_encode($op)))));
$result    = json_decode(trim(file_get_contents('https://themilkmob.org/?s2member_pro_remote_op=1', false, $post_data)), true);
/* Debugging Code 
if ($result && empty($result['error']) && !empty($result['ID'])) {
    echo 'Success. Modified user ID: '.$result['ID'];
    sleep ( 15 );
} elseif (!empty($result['error'])) {
    echo 'API error reads: '.$result['error'];
    sleep ( 15 );
}
*/
}

function get_value_by_label_new( $fields, $entry, $label ) {

	foreach ( $fields as $field ) {
		$lead_key = $field->label;
		if ( strToLower( $lead_key ) == strToLower( $label ) ) {
			return $entry[ $field->id ];
		}
	}
	return false;
}

